/// <reference types="react" />
import * as nbformat from '@jupyterlab/nbformat';
import { Kernel } from "./../../jupyter/services/kernel/Kernel";
import '@jupyterlab/completer/style/index.css';
import '@jupyterlab/documentsearch/style/index.css';
import '@jupyterlab/codemirror/style/index.css';
import '@jupyterlab/notebook/style/index.css';
import '@jupyterlab/theme-light-extension/style/theme.css';
import '@jupyterlab/theme-light-extension/style/variables.css';
import './Notebook.css';
export declare type INotebookProps = {
    uid: string;
    path: string;
    model: nbformat.INotebookContent;
    readOnly: boolean;
    nbgrader: boolean;
    ipywidgets: 'classic' | 'lab';
    store?: any;
    kernel?: Kernel;
    managedContent: boolean;
    cellMetadataPanel: boolean;
    CellSidebar?: (props: any) => JSX.Element;
    cellSidebarMargin: number;
};
/**
 * This component creates a Notebook as a collection of snippets
 * with sidebars.
 *
 * @param props The notebook properties.
 * @returns A Notebook React.js component.
 */
export declare const Notebook: {
    (props: INotebookProps): import("@emotion/react/jsx-runtime").JSX.Element;
    defaultProps: Partial<INotebookProps>;
};
export default Notebook;
