import { CommandRegistry } from '@lumino/commands';
import { BoxPanel } from '@lumino/widgets';
import { ServerConnection, ServiceManager } from '@jupyterlab/services';
import { NotebookPanel } from '@jupyterlab/notebook';
import * as nbformat from '@jupyterlab/nbformat';
import { INotebookProps } from './Notebook';
export declare class NotebookAdapter {
    private _boxPanel;
    private _notebookPanel?;
    private _uid;
    private _serviceManager;
    private _commandRegistry;
    private _props;
    private _model;
    private _tracker?;
    private _kernel?;
    private _store?;
    private _ipywidgets?;
    private _iPyWidgetsClassicManager?;
    private _CellSidebar?;
    private _nbgrader;
    private _readOnly;
    private _managedContent;
    private _context?;
    constructor(props: INotebookProps, serverSettings: ServerConnection.ISettings);
    loadNotebook(notebookPath: string): void;
    get uid(): string;
    get notebookPanel(): NotebookPanel | undefined;
    get commands(): CommandRegistry;
    get panel(): BoxPanel;
    get serviceManager(): ServiceManager;
    setDefaultCellType: (cellType: nbformat.CellType) => void;
    changeCellType: (cellType: nbformat.CellType) => void;
    private doChangeCellType;
    dispose: () => void;
}
export default NotebookAdapter;
