import { Fragment as _Fragment, jsx as _jsx, jsxs as _jsxs } from "@emotion/react/jsx-runtime";
import { ActionList, TextInput } from "@primer/react";
import { CheckIcon } from "@primer/octicons-react";
import { selectNotebook } from '../../NotebookState';
import NbGraderType, { getNbGraderType, setCellGradeType } from './NbGraderCells';
const handleGradeIdChange = (cell, gradeId) => {
    const nbgrader = cell.model.metadata.get("nbgrader");
    cell.model.metadata.set("nbgrader", Object.assign(Object.assign({}, nbgrader), { grade_id: gradeId }));
};
const handlePointsChange = (cell, points) => {
    var p = +points;
    if (!isNaN(p)) {
        const nbgrader = cell.model.metadata.get("nbgrader");
        cell.model.metadata.set("nbgrader", Object.assign(Object.assign({}, nbgrader), { points: p }));
    }
};
export const CellMetadataEditor = (props) => {
    var _a;
    const { cell, nbgrader } = props;
    if (!cell || !cell.model) {
        return _jsx(_Fragment, {}, void 0);
    }
    const cellGradeType = getNbGraderType(cell);
    // TODO Do not remove for now this selectNotebook, otherwise this component will not refresh.
    // TODO Better handle this case with a local state.
    selectNotebook();
    const nbg = (_a = cell.model.metadata) === null || _a === void 0 ? void 0 : _a.get('nbgrader');
    return (_jsx(ActionList, Object.assign({ showDividers: true }, { children: nbgrader &&
            _jsxs(_Fragment, { children: [_jsx(ActionList.Divider, {}, void 0),
                    _jsxs(ActionList.Group, Object.assign({ title: "NbGrader cell type", variant: "subtle" }, { children: [_jsxs(ActionList.Item, Object.assign({ onSelect: e => setCellGradeType(cell, NbGraderType.NotGraded) }, { children: [cellGradeType === NbGraderType.NotGraded && _jsx(ActionList.LeadingVisual, { children: _jsx(CheckIcon, {}, void 0) }, void 0), "None", _jsx(ActionList.Description, Object.assign({ variant: "block" }, { children: "Not a grader cell." }), void 0)] }), void 0),
                            _jsxs(ActionList.Item, Object.assign({ onSelect: e => setCellGradeType(cell, NbGraderType.AutogradedAnswer) }, { children: [cellGradeType === NbGraderType.AutogradedAnswer && _jsx(ActionList.LeadingVisual, { children: _jsx(CheckIcon, {}, void 0) }, void 0), "Autograded answer", _jsx(ActionList.Description, Object.assign({ variant: "block" }, { children: "An autograded answer cell." }), void 0)] }), void 0),
                            _jsxs(ActionList.Item, Object.assign({ role: "listitem", onClick: e => setCellGradeType(cell, NbGraderType.AutogradedTest) }, { children: [cellGradeType === NbGraderType.AutogradedTest && _jsx(ActionList.LeadingVisual, { children: _jsx(CheckIcon, {}, void 0) }, void 0), "Autograded test", _jsx(ActionList.Description, Object.assign({ variant: "block" }, { children: "An autograded test cell." }), void 0)] }), void 0),
                            _jsxs(ActionList.Item, Object.assign({ onSelect: e => setCellGradeType(cell, NbGraderType.ManuallyGradedTask) }, { children: [cellGradeType === NbGraderType.ManuallyGradedTask && _jsx(ActionList.LeadingVisual, { children: _jsx(CheckIcon, {}, void 0) }, void 0), "Manually graded task", _jsx(ActionList.Description, Object.assign({ variant: "block" }, { children: "A manually graded task cell." }), void 0)] }), void 0),
                            _jsxs(ActionList.Item, Object.assign({ onSelect: e => setCellGradeType(cell, NbGraderType.ManuallyGradedAnswer) }, { children: [cellGradeType === NbGraderType.ManuallyGradedAnswer && _jsx(ActionList.LeadingVisual, { children: _jsx(CheckIcon, {}, void 0) }, void 0), "Manually graded answer", _jsx(ActionList.Description, Object.assign({ variant: "block" }, { children: "A manually graded answer cell." }), void 0)] }), void 0),
                            _jsxs(ActionList.Item, Object.assign({ onSelect: e => setCellGradeType(cell, NbGraderType.ReadonlyGraded) }, { children: [cellGradeType === NbGraderType.ReadonlyGraded && _jsx(ActionList.LeadingVisual, { children: _jsx(CheckIcon, {}, void 0) }, void 0), "Readonly", _jsx(ActionList.Description, Object.assign({ variant: "block" }, { children: "A readonly grader cell." }), void 0)] }), void 0)] }), void 0),
                    cellGradeType !== NbGraderType.NotGraded &&
                        _jsx(_Fragment, { children: _jsxs(ActionList.Group, Object.assign({ title: "NbGrader metadata", variant: "subtle" }, { children: [_jsxs(ActionList.Item, { children: ["Grade ID:", nbg &&
                                                _jsx(TextInput, { block: true, value: nbg.grade_id, onChange: e => { e.preventDefault(); handleGradeIdChange(cell, e.target.value); } }, void 0)] }, void 0),
                                    _jsxs(ActionList.Item, { children: ["Points:", nbg &&
                                                _jsx(TextInput, { block: true, value: nbg.points, onChange: e => { e.preventDefault(); handlePointsChange(cell, e.target.value); } }, void 0)] }, void 0)] }), void 0) }, void 0)] }, void 0) }), void 0));
};
export default CellMetadataEditor;
//# sourceMappingURL=CellMetadataEditor.js.map