import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "@emotion/react/jsx-runtime";
import { useState } from 'react';
import { useDispatch } from 'react-redux';
import { ActionMenu, Button, IconButton } from "@primer/react";
import { KebabHorizontalIcon, PlayIcon, RepoDeletedIcon, ArrowUpIcon, ArrowDownIcon } from "@primer/octicons-react";
import { DLA_CELL_HEADER_CLASS } from './base/CellSidebarWidget';
import { notebookActions, selectActiveCell } from '../../NotebookState';
import CellMetadataEditor from '../metadata/CellMetadataEditor';
export const CellSidebarDefault = (props) => {
    const [visible, setVisible] = useState(false);
    const { nbgrader } = props;
    const dispatch = useDispatch();
    const activeCell = selectActiveCell();
    const layout = (activeCell === null || activeCell === void 0 ? void 0 : activeCell.layout);
    if (layout) {
        const cellWidget = layout.widgets[0];
        if (!visible && ((cellWidget === null || cellWidget === void 0 ? void 0 : cellWidget.node.id) === props.id)) {
            setVisible(true);
        }
        if (visible && ((cellWidget === null || cellWidget === void 0 ? void 0 : cellWidget.node.id) !== props.id)) {
            setVisible(false);
        }
    }
    if (!visible) {
        return _jsx("div", {}, void 0);
    }
    return (activeCell ?
        _jsxs("div", Object.assign({ className: DLA_CELL_HEADER_CLASS, css: {
                '& p': {
                    marginBottom: '0 !important',
                }
            } }, { children: [_jsx("span", Object.assign({ style: { display: "flex" } }, { children: _jsx(Button, Object.assign({ trailingIcon: PlayIcon, variant: "invisible", size: "small", onClick: (e) => {
                            e.preventDefault();
                            dispatch(notebookActions.run.started());
                        } }, { children: "Run" }), void 0) }), void 0),
                _jsx("span", Object.assign({ style: { display: "flex" } }, { children: _jsx(Button, Object.assign({ trailingIcon: ArrowUpIcon, variant: "invisible", size: "small", onClick: (e) => {
                            e.preventDefault();
                            dispatch(notebookActions.insertAbove.started("code"));
                        } }, { children: "Code" }), void 0) }), void 0),
                _jsx("span", Object.assign({ style: { display: "flex" } }, { children: _jsx(Button, Object.assign({ trailingIcon: ArrowUpIcon, variant: "invisible", size: "small", onClick: (e) => {
                            e.preventDefault();
                            dispatch(notebookActions.insertAbove.started("markdown"));
                        } }, { children: "Markdown" }), void 0) }), void 0),
                _jsx("span", Object.assign({ style: { display: "flex" } }, { children: _jsx(Button, Object.assign({ trailingIcon: ArrowDownIcon, variant: "invisible", size: "small", onClick: (e) => {
                            e.preventDefault();
                            dispatch(notebookActions.insertBelow.started("markdown"));
                        } }, { children: "Markdown" }), void 0) }), void 0),
                _jsx("span", Object.assign({ style: { display: "flex" } }, { children: _jsx(Button, Object.assign({ trailingIcon: ArrowDownIcon, variant: "invisible", size: "small", onClick: (e) => {
                            e.preventDefault();
                            dispatch(notebookActions.insertBelow.started("code"));
                        } }, { children: "Code" }), void 0) }), void 0),
                _jsx("span", Object.assign({ style: { display: "flex" } }, { children: _jsx(Button, Object.assign({ trailingIcon: RepoDeletedIcon, variant: "invisible", size: "small", onClick: (e) => {
                            e.preventDefault();
                            dispatch(notebookActions.delete.started());
                        } }, { children: "Delete" }), void 0) }), void 0),
                nbgrader &&
                    _jsxs(ActionMenu, { children: [_jsx(ActionMenu.Anchor, { children: _jsx(IconButton, { icon: KebabHorizontalIcon, variant: "invisible", "aria-label": "Open column options" }, void 0) }, void 0),
                            _jsx(ActionMenu.Overlay, { children: _jsx(CellMetadataEditor, { cell: activeCell, nbgrader: nbgrader }, void 0) }, void 0)] }, void 0)] }), void 0)
        :
            _jsx(_Fragment, {}, void 0));
};
export default CellSidebarDefault;
//# sourceMappingURL=CellSidebarDefault.js.map