import React from 'react';
import { Store } from 'redux';
/**
 * Definition of the properties that can be passed
 * when creating a Jupyter context.
 */
export declare type JupyterProps = {
    children: React.ReactNode;
    lite: boolean;
    injectableStore?: Store | any;
    collaborative?: boolean;
    jupyterServerHttpUrl?: string;
    jupyterServerWsUrl?: string;
    jupyterToken?: string;
    terminals?: boolean;
    theme?: any;
};
/**
 * The Jupyter context. This handles the needed initialization
 * and ensure the Redux and the Material UI theme providers
 * are available.
 */
export declare const Jupyter: {
    (props: JupyterProps): import("@emotion/react/jsx-runtime").JSX.Element;
    defaultProps: {
        lite: boolean;
        collaborative: boolean;
        terminals: boolean;
    };
};
export default Jupyter;
