import { applyMiddleware, combineReducers, createStore } from "redux";
import { createEpicMiddleware } from "redux-observable";
import { cellReducer } from "../components/cell/CellState";
import { notebookReducer } from "../components/notebook/NotebookState";
import { terminalReducer } from "../components/terminal/TerminalState";
const epicMiddleware = createEpicMiddleware();
function createReducer(asyncReducers) {
    return combineReducers(Object.assign({ cell: cellReducer, notebook: notebookReducer, terminal: terminalReducer }, asyncReducers));
}
function createInjectableStore() {
    const injectableStore = createStore(createReducer({}), applyMiddleware(epicMiddleware));
    injectableStore.asyncReducers = {};
    injectableStore.inject = (key, asyncReducer, epic) => {
        const reducer = injectableStore.asyncReducers[key];
        if (!reducer) {
            if (epic) {
                epicMiddleware.run(epic);
            }
            injectableStore.asyncReducers[key] = asyncReducer;
            const newReducer = createReducer(injectableStore.asyncReducers);
            injectableStore.replaceReducer(newReducer);
        }
    };
    return injectableStore;
}
/*
export const epic$ = new BehaviorSubject(initEpics);
const rootEpic = (action$: any, state$: any, deps: any) => epic$.pipe(
  mergeMap(epic => epic(action$, state$, deps))
);
epicMiddleware.run(rootEpic);
*/
const injectableStore = createInjectableStore();
export default injectableStore;
//# sourceMappingURL=Store.js.map